<?php
/**
 * Add Users Page
 *
 * Copyright 2004 (c) Tim Perdue - GForge LLC
 * Copyright 2010 (c) Franck Villaume - Capgemini
 * http://fusionforge.org
 *
 * This file is part of FusionForge. FusionForge is free software;
 * you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the Licence, or (at your option)
 * any later version.
 *
 * FusionForge is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with FusionForge; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

require_once('../../../env.inc.php');
require_once $gfcommon.'include/pre.php';
require_once $gfcommon.'preplugins.php';
require_once '../mailman_utils.php';

$request =& HTTPRequest::instance();
$group_id = $request->get('group_id');
$group_list_id = $request->get('group_list_id');
$add_email=$request->get('add_email');

session_require_perm ('project_admin', $group_id) ;

if ($add_email == 1) {
	session_redirect('/plugins/mailman/admin/addemails.php?group_id='.$group_id.'&group_list_id='.$group_list_id);
}

$group = group_get_object($group_id);
if (!$group || !is_object($group)) {
    exit_no_group();
} elseif ($group->isError()) {
	exit_error($group->getErrorMessage(),'admin');
}

$ml = new MailmanList($group_id,$group_list_id);

if(!$ml || !is_object($ml)) {
	$error_msg = _('Error getting the list');
	session_redirect('/plugins/mailman/admin/index.php?group_id='.$group_id.'&error_msg='.urlencode($error_msg));
} elseif($ml->isError()) {
	$error_msg = $ml->getErrorMessage();
	session_redirect('/plugins/mailman/admin/index.php?group_id='.$group_id.'&error_msg='.urlencode($error_msg));
} else {	
	$listname = $ml->getName();
}

$sw = getStringFromRequest('sw', 'A');

if ($sw == _('Project Member List')) {
	$res = db_query_params('SELECT DISTINCT us.user_id,user_name,lastname,firstname,email FROM users us, pfo_user_role ur, pfo_role ro WHERE status=$1 and type_id=1 and us.user_id=ur.user_id and ur.role_id=ro.role_id and ro.home_group_id=$2 ORDER BY lastname,firstname ASC',
			array('A',$group_id));
} else {
	$res = db_query_params('SELECT user_id,user_name,lastname,firstname,email FROM users WHERE status=$1 and type_id=1 and lower(lastname) LIKE $2 ORDER BY lastname,firstname ASC',
			array('A',
	 		strtolower ($sw."%")));
}

$accumulated_ids = getStringFromRequest('accumulated_ids');
if (!$accumulated_ids) {
	$accumulated_ids=array();
} else {
	$accumulated_ids = explode(',',$accumulated_ids);
}

$newids = getArrayFromRequest('newids');
if (count($newids) > 0) {
	if (count($accumulated_ids) > 0) {
		$accumulated_ids = array_merge($accumulated_ids,$newids);
	} else {
		$accumulated_ids=$newids;
	}
}
$accumulated_ids = array_unique($accumulated_ids);

if (getStringFromRequest('finished')) {
	session_redirect('/plugins/mailman/admin/finish_addusers.php?group_id='.$group_id.'&group_list_id='.$group_list_id.'&accumulated_ids='.implode(',',$accumulated_ids));
}

mailman_header(array(
'title' => _('Add members to the List').' '.$listname,
				'help'=>'CommunicationServices.html#MailingLists',
				'admin'=>1)
);	
if ($ml->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE || $ml->isPublic() == MAIL__MAILING_LIST_IS_PUBLIC_MODERATE) {	
	echo '<ul>
		<li>
			<a href="/plugins/mailman/admin/pending_users.php?group_id='.$group_id.'&group_list_id='.$group_list_id.'">'._('Manage subscriptions awaiting approval').'</a>
			</li>
			</ul>';
}
echo '<ul>
	<li>
		<a href="/plugins/mailman/admin/addemails.php?group_id='.$group_id.'&group_list_id='.$group_list_id.'">'._('Add emails for users with no account').'</a>
	</li>
	</ul>';
echo '
<p>
'._('Check the box next to the name of the user(s) you want to add. Your choices will be preserved if you click any of the letters below. When done, click « Finish ».').'
</p>
<form action="'.getStringFromServer('PHP_SELF').'?group_id='.$group_id.'&group_list_id='.$group_list_id.'" method="post">
<input type="hidden" name="accumulated_ids" value="'. implode(',',$accumulated_ids) .'" />';

$abc_array = array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',_('Project Member List'));
echo '<p>' . _('Choose the <strong>first Letter</strong> of the name of the person you wish to add or choose a person from the <strong>project member list</strong>') . '</p>';
for ($i=0; $i<count($abc_array); $i++) {
    if ($sw == $abc_array[$i]) {
        echo '<strong>'.$abc_array[$i].'</strong>&nbsp;';
    } else {
        echo '<input type="submit" name="sw" value="'.$abc_array[$i].'" />&nbsp;';
    }
}

if (!$res || db_numrows($res) < 1) {
	echo '<p>' . _('No Matching Users Found') . '</p>';
} else {

	$titles[]=_('Real name');
	$titles[]=_('Login');
	$titles[]=_('E-mail');
	$titles[]=_('Add user');

	echo $HTML->listTableTop($titles);

	for ($i=0; $i<db_numrows($res); $i++) {
		$uid = db_result($res,$i,'user_id');
		echo '<tr '. $HTML->boxGetAltRowStyle($i) . '>
			<td>'.db_result($res,$i,'lastname').', '.db_result($res,$i,'firstname').'</td>
			<td>'.db_result($res,$i,'user_name').'</td>
			<td>'.db_result($res,$i,'email').'</td>
			<td><input type="checkbox" name="newids[]" value="'. $uid .'"';
		if (in_array($uid, $accumulated_ids)) {
			echo ' checked="checked" ';
		}
		echo ' /></td></tr>';

	}

	echo $HTML->listTableBottom();

}
echo '<p><input type="submit" name="finished" value="'._('Finish').'" /></p>
</form>';

mail_footer(array());

// Local Variables:
// mode: php
// c-file-style: "bsd"
// End:

?>
