<?php
/**
 * FusionForge Mailing Lists Facility
 *
 * Portions Copyright 1999-2001 (c) VA Linux Systems
 * The rest Copyright 2003 (c) Guillaume Smet
 * Portions Copyright 2010 (c) Mélanie Le Bail
 *
 * @version   $Id$
 *
 */


require_once 'mailman/include/MailmanList.class.php';
require_once 'mailman/include/MailmanListFactory.class.php';
global $class;
$current_user=UserManager::instance()->getCurrentUser();

function sendCreationMail($userEmail,&$list) {
	$message = sprintf(_('A mailing list will be created on %1$s in few minutes
and you are the list administrator.

This list is: %3$s@%2$s .

Your mailing list info is at:
%4$s .

List administration can be found at:
%5$s .

Your list password is: %6$s .
You are encouraged to change this password as soon as possible.

Thank you for registering your project with %1$s.

-- the %1$s staff
'), forge_get_config ('forge_name'), forge_get_config('lists_domain'), $list->getName(), $list->getExternalInfoUrl(), util_make_url('/mailman/admin/'.$list->getName()), $list->getPassword());
	$mailSubject = sprintf(_('%1$s New Mailing List'), forge_get_config ('forge_name'));

	util_send_message($userEmail, $mailSubject, $message, 'noreply@'.forge_get_config('lists_domain'));
}

function sendPasswordMail(&$list) {
	$message = sprintf(_('You are the administrator of the list : %3$s@%2$s .

Your list password is: %4$s .

-- the %1$s staff
'), forge_get_config ('forge_name'), forge_get_config('lists_domain'), $list->getName(), $list->getPassword());
	$mailSubject = sprintf(_('%1$s - Information'), forge_get_config ('forge_name'));	
	$current_user=UserManager::instance()->getCurrentUser();
	$userMail = $current_user->getEmail();
	
	util_send_message($userMail, $mailSubject, $message, 'noreply@'.forge_get_config('lists_domain'));
}

function sendSubscriptionMail(&$list) {	
	$current_user=UserManager::instance()->getCurrentUser();
	$userEmail = $current_user->getEmail();
	$group_id = $list->Group->getID();
	$message = sprintf(_('Your authorization is required for a mailing list subscription request approval:

    For:  %1$s
    List: %2$s@%3$s

At your convenience, visit:

    %4$s

to process the request.'),
	$userEmail, $list->getName(), forge_get_config ('lists_domain'), util_make_url('plugins/mailman/admin/pending_users.php?group_id='.$group_id.'&group_list_id='.$list->getID()));
	$mailSubject = sprintf(_('%1$s - New subscription request to list "%2$s"'), forge_get_config ('forge_name'),$list->getName());
	$admins =& $list->Group->getAdmins();
	for ($i=0; $i<count($admins); $i++) {
		setup_gettext_for_user ($admins[$i]) ;
		$adminEmail = $admins[$i]->getEmail();
		util_send_message($adminEmail, $mailSubject, $message, 'noreply@'.forge_get_config('lists_domain'));	
	}
	setup_gettext_from_context();
}

function table_begin()
{

	echo "<table class='border' width='100%' border='0'>
            <tr class='boxtable'>
                <th class='forumml' width='15%'>"._('Mailing List')."</th>
                <th class='forumml' width='25%'>"._('Address')."</th>
                <th class='forumml' width='25%'>"._('Description')."</th>
                <th class='forumml' width='10%'>"._('Archives')."</th>";
  	if (isLogged()) {
		$request =& HTTPRequest::instance();
		if (forge_check_perm ('project_admin', $request->get('group_id'))) {
      		echo "<th class='forumml' width='15%'>"._('List of members')."</th>";
		}
		echo "<th class='forumml' width='10%'>"._('Subscription')."</th>";	}
	
}

function table_begin_admin()
{

  echo "<table class='border' width='100%' border='0'>
            <tr class='boxtable'>
                <th class='forumml' width='10%'>"._('Mailing List')."</th>
                <th class='forumml' width='5%'>"._('Update')."</th>";
	  echo "<th class='forumml' width='5%'>"._('Delete')."</th>";
      echo "<th class='forumml' width='8%'>"._('List of members')."</th>";
	  echo "<th class='forumml' width='8%'>"._('Add Users')."</th>";
	  echo "<th class='forumml' width='8%'>"._('Delete Users')."</th>";
	  echo "<th class='forumml' width='5%'>"._('Manage password')."</th>";
	  echo "<th class='forumml' width='8%'>"._('Administrate from Mailman')."</th>";

}

function table_end($private)
{
	echo '</table>';
	if ($private > 0) {
		echo '<p>(*) '._('Private list').'</p>';
	}
}
function display_list($currentList)
{
global $class;
$plugin_manager = PluginManager::instance();
$p = $plugin_manager->getPluginByName('mailman');
	$request =& HTTPRequest::instance();
	$current_user=UserManager::instance()->getCurrentUser();

	if($currentList->isPublic()!= MAIL__MAILING_LIST_IS_DELETED){
		if ($currentList->isError()) {
			echo $currentList->getErrorMessage();
		} else {
			if ($class=="boxitem bgcolor-white") {
				$class="boxitemalt bgcolor-grey";
			}
			else {
				$class = "boxitem bgcolor-white";
			}
			echo "<tr class='".$class."'>";
			echo '<td>';
			if ($currentList->isMonitoring()) {
				if ($currentList->isHidden()) {
					echo '<img src ="'.$p->getThemePath().'/images/ic/ask.png"'.' title="You are waiting for subscription">';
				} else {
					echo '<img src ="'.$p->getThemePath().'/images/ic/tick.png"'.' title="You are monitoring this list">';
				}
			}
			if ($currentList->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE || $currentList->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE_NOT_MODERATE) {
				echo $currentList->getName().'(*)</td> ';
			} else {
				echo $currentList->getName().'</td> ';
			}
			echo '<td>';
			if($currentList->getStatus() == MAIL__MAILING_LIST_IS_REQUESTED) {
				if($currentList->activationRequested()){
					echo	_('Not activated yet');
				}
				else{
					echo _('Error during creation');
				}
				echo '</td><td></td>';
				if (isLogged()) {
					echo '<td></td><td></td><td></td>';
				}
			} else {
				echo '<a href="&#109;&#097;&#105;&#108;&#116;&#111;:'.$currentList->getListEmail().'">'.$currentList->getListEmail(). '</a></td>';
				echo '<td>';
				echo htmlspecialchars($currentList->getDescription()).'</td>';
				$archives =' <a href="index.php?group_id='.$request->get('group_id').'&amp;action=pipermail&amp;id='.$currentList->getID().'">'._('Archives').'</a>';
				plugin_hook('browse_archives', array('html' => &$archives, 'group_list_id' => $currentList->getID()));
				echo '<td>'.$archives.'</td>';
				if(isLogged())
				{
					echo '<td>';
					if (forge_check_perm ('project_admin', $request->get('group_id'))) {
						echo ' <a href="listmembers.php?group_id='.$request->get('group_id').'&group_list_id='.$currentList->getID().'">'._('List of members').'</a>';
						echo ' </td><td>';
					}
					if (strCmp($currentList->getName(),$currentList->Group->getUnixName()) != 0) {				
						if ($currentList->isMonitoring()) {
							echo ' <a href="index.php?group_id='.$request->get('group_id').'&action=unsubscribe&id='.$currentList->getID().'"><img src="'.$p->getThemePath().'/images/ic/delete.png" title='._('Unsubscribe').'>';
							echo ' </a></td>';
						} else {
							echo ' <a href="index.php?group_id='.$request->get('group_id').'&action=subscribe&id='.$currentList->getID().'"><img src="'.$p->getThemePath().'/images/ic/add.png" title='._('Subscribe').'>';
							;
							echo  '</a></td>';
						}
					}		
				}
			}
			echo '</td></tr>';

		}
	}

}
function display_list_admin($currentList)
{
	global $class;
	$request =& HTTPRequest::instance();
	$current_user=UserManager::instance()->getCurrentUser();
	if($currentList->isPublic()!=MAIL__MAILING_LIST_IS_DELETED){
		if ($currentList->isError() ) {
			echo $currentList->getErrorMessage();
		} else
		{
			if ($class=="boxitem bgcolor-white") {
				$class="boxitemalt bgcolor-grey";
			}
			else {
				$class = "boxitem bgcolor-white";
			}

			echo "<tr class='".$class."'>";
			if ($currentList->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE || $currentList->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE_NOT_MODERATE) {
				echo '<td><strong>'.$currentList->getName().'</strong>(*)<br />'.htmlspecialchars($currentList->getDescription()).'</td> ';			
			} else {
				echo '<td><strong>'.$currentList->getName().'</strong><br />'.htmlspecialchars($currentList->getDescription()).'</td> ';
			}
		}
		if($currentList->getStatus() == MAIL__MAILING_LIST_IS_REQUESTED) {
			if($currentList->activationRequested()){
				echo	'<td>'._('Not activated yet').'</td>';
			}
			else{
				echo '<td>'._('Error during creation').'  <a href="/plugins/mailman/admin/index.php?group_id='.$request->get('group_id').'&amp;action=recreate&amp;group_list_id='.$currentList->getID().'">'._('Re-create').'</a></td>';
			}
			echo '<td></td><td></td><td></td>';
		} else {

			echo '<td> <a href="index.php?group_id='.$request->get('group_id').'&amp;change_status=1&amp;group_list_id='.$currentList->getID().'">'._('Update').'</a></td>';
			echo '<td> <a href="deletelist.php?group_id='.$currentList->Group->getID().'&id='.$currentList->getID().'">'. _('Delete').'</td>';

			if (forge_check_perm ('project_admin', $request->get('group_id'))) {
				echo ' <td> <a href="../listmembers.php?group_id='.$request->get('group_id').'&group_list_id='.$currentList->getID().'&admin=1">'._('List of members').'</a></td> ';
				if (strCmp($currentList->getName(),$currentList->Group->getUnixName()) != 0) {
					echo ' <td> <a href="addusers.php?group_id='. $request->get('group_id').'&amp;group_list_id='. $currentList->getID() .'">'._('Add Users').'</a></td> ';
					echo ' <td> <a href="delusers.php?group_id='. $request->get('group_id').'&amp;group_list_id='. $currentList->getID() .'">'._('Delete Users').'</a></td> ';
				} else {
					echo ' <td> </td> <td> </td>';
				}
				echo ' <td> <a href="index.php?group_id='. $request->get('group_id').'&amp;action=managepw&amp;group_list_id='. $currentList->getID() .'">'._('Manage password').'</a></td> ';
				echo ' <td> <a href="index.php?group_id='. $request->get('group_id').'&amp;action=admin&amp;group_list_id='. $currentList->getID() .'">'._('Administrate from Mailman').'</a></td> ';
			}
		}

		echo ' </tr>';
	}
}


function mailman_header($params) {
	//global $group_id;
	global $HTML;
	$current_user=UserManager::instance()->getCurrentUser();
	$request =& HTTPRequest::instance();

	//required for site_project_header
	$params['group'] = $request->get('group_id');
	$params['toptab'] = 'mailman';
	
	$group_id = $request->get('group_id');
	$labels = array();
	$links = array();
	$labels[] = _('View Lists');
	$links[]  = 'plugins/mailman/index.php?group_id='.$group_id;
	if (session_loggedin()) {
		if (forge_check_perm ('project_admin', $group_id)) {
			$labels[] = _('Administration');
			$links[]  = 'plugins/mailman/admin/index.php?group_id='.$group_id;
		}
	}
	$params['submenu'] = $HTML->subMenu($labels,$links);
	site_project_header($params);
	echo '<p><b>';
	
	if ($params['help']) {
		helpButton($params['help']);
	}
	echo "</b></p>\n";
}

function mail_footer($params) {
	site_project_footer($params);
}


// Local Variables:
// mode: php
// c-file-style: "bsd"
// End:

?>
